<template>
    <div class="body">
        <h4 class="text-center">
            {{ field ? field.complete_info : "Complete info" }}
        </h4>
        <div class="row">
            <div class="col-md-5">
                <vue-dropzone
                    ref="myVueDropzone"
                    id="dropzone"
                    :options="dropzoneOptions"
                    :useCustomSlot="true"
                    v-on:vdropzone-success="fileCharged"
                >
                    <div class="dropzone-custom-content">
                        <h3 class="text-primary">
                            <i
                                class="zmdi zmdi-cloud-upload"
                                style="font-size:32px"
                            ></i>
                        </h3>
                        <h3 class="text-center">
                            {{
                                field.dropzone
                                    ? field.dropzone.title
                                    : "Drag and drop to upload content!"
                            }}
                        </h3>
                        <div class="text-center">
                            {{
                                field.dropzone
                                    ? field.dropzone.subtitle
                                    : "...or click to select a file from your computer"
                            }}
                        </div>
                    </div>
                </vue-dropzone>
            </div>
            <div class="col-md-7 align-self-center">
                <div class="form-group">
                    <input
                        v-model="membership.type"
                        value="agency"
                        type="checkbox"
                        name="agency"
                        @click="checked"
                    />
                    <label for="agency">Agencias</label>

                    <input
                        v-model="membership.type"
                        value="agents"
                        type="checkbox"
                        name="agents"
                        @click="checked"
                    />
                    <label for="agents">Agentes</label>

                    <input
                        v-model="membership.type"
                        value="all"
                        type="checkbox"
                        name="all"
                        @click="checked"
                    />
                    <label for="agents">ALL</label>
                </div>
                <div class="form-group">
                    <input
                        v-model="membership.title"
                        type="text"
                        class="form-control"
                        :placeholder="field ? field.title : 'title'"
                    />
                    <div
                        class="text-danger"
                        v-if="!$v.membership.title.required"
                    >
                        {{
                            field.messages
                                ? field.messages.required
                                : "Required"
                        }}
                    </div>
                </div>
                <div class="form-group">
                    <input
                        v-model="membership.price"
                        type="number"
                        step=".01"
                        class="form-control"
                        min="0"
                        :placeholder="field ? field.price : 'price'"
                    />
                    <div
                        class="text-danger"
                        v-if="!$v.membership.price.required"
                    >
                        {{
                            field.messages
                                ? field.messages.required
                                : "Required"
                        }}
                    </div>
                    <div
                        class="text-danger"
                        v-if="!$v.membership.price.minValue"
                    >
                        {{
                            field.messages
                                ? field.messages.minValue + "USD"
                                : "Min Value"
                        }}
                    </div>
                </div>
                <div class="form-group">
                    <input
                        v-model="membership.properties"
                        type="number"
                        class="form-control"
                        min="0"
                        :placeholder="field ? field.properties : 'price'"
                    />
                    <div
                        class="text-danger"
                        v-if="!$v.membership.properties.required"
                    >
                        {{
                            field.messages
                                ? field.messages.required
                                : "Required"
                        }}
                    </div>
                    <div
                        class="text-danger"
                        v-if="!$v.membership.properties.minValue"
                    >
                        {{
                            field.messages
                                ? field.messages.minValue + "USD"
                                : "Min Value"
                        }}
                    </div>
                </div>
                <div class="form-group">
                    <input
                        v-model="membership.admin_agency"
                        type="number"
                        class="form-control"
                        min="0"
                        :placeholder="field ? field.admin_agency : 'price'"
                    />
                    <div
                        class="text-danger"
                        v-if="!$v.membership.admin_agency.required"
                    >
                        {{
                            field.messages
                                ? field.messages.required
                                : "Required"
                        }}
                    </div>
                    <div
                        class="text-danger"
                        v-if="!$v.membership.admin_agency.minValue"
                    >
                        {{
                            field.messages
                                ? field.messages.minValue + "USD"
                                : "Min Value"
                        }}
                    </div>
                </div>
                <div class="form-group">
                    <input
                        v-model="membership.agency_agent"
                        type="number"
                        class="form-control"
                        min="0"
                        :placeholder="field ? field.agency_agent : 'price'"
                    />
                    <div
                        class="text-danger"
                        v-if="!$v.membership.agency_agent.required"
                    >
                        {{
                            field.messages
                                ? field.messages.required
                                : "Required"
                        }}
                    </div>
                    <div
                        class="text-danger"
                        v-if="!$v.membership.agency_agent.minValue"
                    >
                        {{
                            field.messages
                                ? field.messages.minValue + "USD"
                                : "Min Value"
                        }}
                    </div>
                </div>
                <div class="form-group">
                    <textarea
                        v-model="membership.description"
                        class="form-control"
                        :placeholder="field ? field.description : 'description'"
                    >
                    </textarea>
                    <div
                        class="text-danger"
                        v-if="!$v.membership.description.required"
                    >
                        {{
                            field.messages
                                ? field.messages.required
                                : "Required"
                        }}
                    </div>
                </div>
                <div class="form-group">
                    <vue-google-autocomplete
                        ref="address"
                        id="map"
                        classname="form-control"
                        :placeholder="field ? field.country : 'select_address'"
                        v-on:placechanged="getAddressData"
                        types="(regions)"
                    >
                    </vue-google-autocomplete>
                </div>
                <button
                    v-if="!$v.membership.$invalid"
                    class="btn btn-success btn-large float-right btn-block"
                    @click.prevent="postMembership"
                >
                    {{ field ? field.submit : "submit" }}
                </button>
            </div>
        </div>
    </div>
</template>
<script>
import vue2Dropzone from "vue2-dropzone";
import "vue2-dropzone/dist/vue2Dropzone.min.css";
import { required, decimal, minValue } from "vuelidate/lib/validators";
import VueGoogleAutocomplete from "vue-google-autocomplete";
export default {
    props: ["lang"],
    components: {
        vueDropzone: vue2Dropzone,
        VueGoogleAutocomplete
    },
    data() {
        return {
            field: this.lang,

            errorMsg: null,

            membership: {
                feature_image: null,
                title: null,
                description: null,
                price: null,
                country: null,
                properties: null,
                admin_agency: null,
                agency_agent: null,
                type: ["all"]
            },
            dropzoneOptions: {
                url: "/api/files/stored",
                addRemoveLinks: true,
                thumbnailWidth: 150,
                maxFilesize: 0.5,
                acceptedFiles: "image/*",
                capture: true,
                uploadMultiple: false,
                maxFiles: 1
            }
        };
    },
    validations: {
        membership: {
            title: {
                required
            },
            description: {
                required
            },
            price: {
                required,
                decimal,
                minValue: minValue(0)
            },
            properties: {
                required,
                minValue: minValue(0)
            },
            admin_agency: {
                required,
                minValue: minValue(0)
            },
            agency_agent: {
                required,
                minValue: minValue(0)
            }
        }
    },
    methods: {
        getAddressData: function(addressData, placeResultData, id) {
            console.log(addressData, placeResultData, id);

            this.membership.country = addressData.country;
        },
        fileCharged(file, res) {
            this.membership.feature_image = res;
        },
        postMembership() {
            axios
                .post("/api/memberships", this.membership)
                .then(res => {
                    // console.log(res.data);
                    location.href = "/dashboard/agency/memberships";
                })
                .catch(err => {
                    console.log(err.response.data);
                });
        },
        checked(e) {
            if (e.target.checked) {
                if (
                    this.membership.type.length >= 1 &&
                    this.membership.type[0] != "all"
                ) {
                    this.membership.type = ["all"];
                    e.target.checked = false;
                    return false;
                }
                if (this.membership.type[0] == "all") {
                    this.membership.type = [e.target.value];
                } else {
                    this.membership.type.push(e.target.value);
                }
            }
        }
    }
};
</script>
